/* Programme OpenGL + GLUt complet              */
/*                                              */
/* Auteur: Nicolas JANEY                        */
/* nicolas.janey@univ-fcomte.fr                 */
/* Septembre 2012                               */

#include <stdlib.h>
#include <stdio.h>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

/* Variables et constantes globales             */
/* pour les angles et les couleurs utilises     */

static int mode = 1;
static float r0 = 0.0F;
static float r1 = 0.0F;
static float r2 = 0.0F;
static const float blanc[] = { 1.0F,1.0F,1.0F,1.0F };
static const float jaune[] = { 1.0F,1.0F,0.0F,1.0F };
static const float rouge[] = { 1.0F,0.0F,0.0F,1.0F };
static const float vert[] = { 0.0F,1.0F,0.0F,1.0F };
static const float bleu[] = { 0.0F,0.0F,1.0F,1.0F };

/* Fonction d'initialisation des parametres     */
/* OpenGL ne changeant pas au cours de la vie   */
/* du programme                                 */

static void init(void) {
  const GLfloat shininess[] = { 50.0 };
  glMaterialfv(GL_FRONT,GL_SPECULAR,blanc);
  glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,rouge);
  glLightfv(GL_LIGHT1,GL_DIFFUSE,jaune);
  glLightfv(GL_LIGHT2,GL_DIFFUSE,bleu);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT1);
  glEnable(GL_LIGHT2);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  glEnable(GL_AUTO_NORMAL);
}

/* Scene dessinee                               */

static void scene1(void) {
  glPushMatrix();
  glPushMatrix();
  glTranslatef(2.0F,0.0F,2.0F);
  glutSolidCube(2.0);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(2.0F,0.0F,-2.0F);
  glutSolidCube(2.0);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-2.0F,0.0F,2.0F);
  glutSolidCube(2.0);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-2.0F,0.0F,-2.0F);
  glutSolidCube(2.0);
  glPopMatrix();
  glPopMatrix();
}

static void scene2(void) {
  glPushMatrix();
  glPushMatrix();
  glTranslatef(2.0F,0.0F,2.0F);
  glutSolidSphere(1.0,36,18);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(2.0F,0.0F,-2.0F);
  glutSolidSphere(1.0,36,18);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-2.0F,0.0F,2.0F);
  glutSolidSphere(1.0,36,18);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-2.0F,0.0F,-2.0F);
  glutSolidSphere(1.0,36,18);
  glPopMatrix();
  glPopMatrix();
}

/* Fonction executee lors d'un rafraichissement */
/* de la fenetre de dessin                      */

static void display1(void) {
  glClearColor(0.3F,0.3F,0.3F,0.5F);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  const GLfloat light0_position[] = { 0.0,0.0,0.0,1.0 };
  const GLfloat light1_position[] = { -1.0,1.0,1.0,0.0 };
  const GLfloat light2_position[] = { 1.0,-1.0,1.0,0.0 };
  glLightfv(GL_LIGHT0,GL_POSITION,light0_position);
  glLightfv(GL_LIGHT1,GL_POSITION,light1_position);
  glLightfv(GL_LIGHT2,GL_POSITION,light2_position);
  glPolygonMode(GL_FRONT_AND_BACK,( mode ) ? GL_FILL : GL_LINE);
  glPushMatrix();
  glRotatef(r0,1.0,0.0,0.0);
  glRotatef(r1,0.0,1.0,0.0);
  glRotatef(r2,0.0,0.0,1.0);
  scene1();
  glPopMatrix();
  glFlush();
  glutSwapBuffers();
  int error = glGetError();
  if ( error != GL_NO_ERROR )
    printf("Attention erreur %d\n",error);
}

static void display2(void) {
  glClearColor(0.3F,0.3F,0.3F,0.5F);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  const GLfloat light0_position[] = { 0.0,0.0,0.0,1.0 };
  const GLfloat light1_position[] = { -1.0,1.0,1.0,0.0 };
  const GLfloat light2_position[] = { 1.0,-1.0,1.0,0.0 };
  glLightfv(GL_LIGHT0,GL_POSITION,light0_position);
  glLightfv(GL_LIGHT1,GL_POSITION,light1_position);
  glLightfv(GL_LIGHT2,GL_POSITION,light2_position);
  glPolygonMode(GL_FRONT_AND_BACK,( mode ) ? GL_FILL : GL_LINE);
  glPushMatrix();
  glRotatef(r0,1.0,0.0,0.0);
  glRotatef(r1,0.0,1.0,0.0);
  glRotatef(r2,0.0,0.0,1.0);
  scene2();
  glPopMatrix();
  glFlush();
  glutSwapBuffers();
  int error = glGetError();
  if ( error != GL_NO_ERROR )
    printf("Attention erreur %d\n",error);
}

/* Fonction executee lorsqu'aucun evenement     */
/* n'est en file d'attente                      */

static void idle(void) {
  r0 += 0.3355F;
  r1 += 0.6117F;
  r2 += 0.4174F;
  glutPostRedisplay();
}

//////////////////////////////////////////////////

/* Fonction executee lors d'un changement       */
/* de la taille de la fenetre OpenGL            */

static void reshape(int x,int y) {
  glViewport(0,0,x,y); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(5.0F,(float) x/y,90.0,110.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(57.735,57.735,57.735,
             0.0  , 0.0  , 0.0,
             0.0  , 1.0  , 0.0);
}

//////////////////////////////////////////////////

/* Fonction executee lors de l'appui            */
/* d'une touche alphanumerique du clavier       */

static void keyboard(unsigned char key,int x,int y) {
  switch (key) {
    case 0x0D :
      { static int anim = 0;
        anim = !anim;
        glutIdleFunc(( anim ) ? idle : NULL); }
      break;
    case 0x20 :
      { static int objet = 1;
        objet = !objet;
        glutDisplayFunc(( objet ) ? display1 : display2); }
      glutPostRedisplay();
      break;
    case 'm' :
      { mode = !mode; }
      glutPostRedisplay();
      break;
    case 0x1B :
      exit(0);
      break; }
}

/* Fonction principale                          */

int main(int argc,char **argv) {
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
  glutInitWindowSize(300,300);
  glutInitWindowPosition(50,50);
  glutCreateWindow("Quatre objets en gros plan");
  init();
  glutKeyboardFunc(keyboard);
  glutReshapeFunc(reshape);
  //glutIdleFunc(idle);
  glutDisplayFunc(display1);
  glutMainLoop();
  return(0);
}
